unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, ExtCtrls, StdCtrls, Spin, Menus;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    Exit1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    SpinEdit1: TSpinEdit;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Label1: TLabel;
    Initialize: TButton;
    Image1: TImage;
    StringGrid1: TStringGrid;
    StringGrid2: TStringGrid;
    c0: TEdit;
    Label6: TLabel;
    Label7: TLabel;
    MCA: TEdit;
    Label8: TLabel;
    Label9: TLabel;
    MCX: TEdit;
    Label10: TLabel;
    Label11: TLabel;
    sahen_out: TEdit;
    Calc_Left: TButton;
    uhen_out: TEdit;
    CalcRight: TButton;
    XConc: TEdit;
    Label12: TLabel;
    RefineX: TButton;
    StringGrid3: TStringGrid;
    Abundance1: TMenuItem;
    conductivity: TEdit;
    Label13: TLabel;
    Button2: TButton;
    Button3: TButton;
    SpinEdit3: TSpinEdit;
    Label14: TLabel;
    SpinEdit4: TSpinEdit;
    Label15: TLabel;
    Button4: TButton;
    selectcol: TSpinEdit;
    selectrow: TSpinEdit;
    cellvalue: TEdit;
    Adopt: TButton;
    Model_1: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    SpinEdit2: TSpinEdit;
    CheckBox1: TCheckBox;
    GroupBox2: TGroupBox;
    Button1: TButton;
    beta1: TEdit;
    Label2: TLabel;
    Option1: TMenuItem;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    procedure Exit1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure InitializeClick(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure SpinEdit2Change(Sender: TObject);
    procedure Calc_LeftClick(Sender: TObject);
    procedure CalcRightClick(Sender: TObject);
    procedure RefineXClick(Sender: TObject);
    procedure Abundance1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure StringGrid2SelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure AdoptClick(Sender: TObject);
    procedure Option1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;
  dirinfo0 : string;
  dirinfo : string;
  txt : TextFile;
  FileDum : string;
  ndata : integer;
  nscl : integer;
  i : integer;

  stepKFile : string;
  nstepK : integer;

  datapoint: integer;

  xmin, xmax: extended;
  ymin, ymax: extended;
  zmin, zmax: extended;

  x: array[0..100] of extended;
  y: array[0..100] of extended;
  k: array[0..100] of extended;
  b: array[0..100] of extended;
  ab : array[0..100] of extended;
  scl : array[0..100] of extended;


  z: array[0..100] of extended;

  gxmin,gxmax,gymin,gymax : extended;
  dxmin,dxmax,dymin,dymax : extended;
  gheight,gwidth : integer;
  yscale : extended;
  maru : byte;

  ct,cx : extended;

implementation

uses Unit2, Unit3;

{$R *.DFM}

function fx (x: extended): integer;
  begin
   fx := round(gwidth * (x - gxmin) / (gxmax - gxmin));
  end;

function fy (y: extended): integer;
  begin
   fy := gheight - round(gheight * (y - gymin) / (gymax - gymin));
  end;

function sahen (c0,x: extended): extended;
  begin
   sahen := (Form1.SpinEdit1.value*c0 - x)/c0;
  end;

function uhen (x: extended): extended;
  var
    v2,v_top,v_bottom : extended;
    ii,jj : integer;
  begin


    v_top := b[1]*x;
    for ii := 2 to Form1.SpinEdit1.value do
      begin
        v2 := ii*b[ii];
        for jj := 1 to ii do
          begin
            v2 := v2*x;
          end;
        v_top := v_top + v2;
      end;

    v_bottom := 1+b[1]*x;
    for ii := 2 to Form1.SpinEdit1.value do
      begin
        v2 := b[ii];
        for jj := 1 to ii do
          begin
            v2 := v2*x;
          end;
        v_bottom := v_bottom + v2;
      end;

    uhen := v_top/v_bottom;

  end;

function conduct (x: extended): extended;
  var
    v1,v2,v3 : extended;
    ii,jj : integer;
    total : extended;
  begin

    v1 := StrToFloat(Form1.MCX.text)*x;

    total := 1;
    for ii := 1 to Form1.SpinEdit1.value do
      begin
        v2 := b[ii];
        for jj := 1 to ii do
          begin
            v2 := v2*x;
          end;
        total := total + v2;
      end;


    v3 := scl[0]*Form1.SpinEdit1.value;
    for ii := 1 to Form1.SpinEdit1.value-1 do
      begin
        v2 := scl[ii]*(Form1.SpinEdit1.value-ii)*b[ii];
        for jj := 1 to ii do
          begin
            v2 := v2*x;
          end;
        v3 := v3 + v2;
      end;

    v1 := v1 + ct*StrToFloat(Form1.MCA.text)*v3/total;


    ab[0] := 100 / total;
    for ii := 1 to Form1.SpinEdit1.value do
      begin

        v2 := b[ii];
        for jj := 1 to ii do
          begin
            v2 := v2*x;
          end;

        ab[ii] := 100*v2/total;
      end;

    Form1.StringGrid3.RowCount := Form1.SpinEdit1.value + 2;

    Form1.StringGrid3.Cells[0,0] := 'Species';
    Form1.StringGrid3.Cells[1,0] := 'abundance%';
    Form1.StringGrid3.Cells[2,0] := 'conc (M)';

    for ii := 0 to Form1.SpinEdit1.value do
      begin
        Form1.StringGrid3.Cells[0,ii+1] := 'AX'+FloatToStr(ii);
        Form1.StringGrid3.Cells[1,ii+1] := FloatToStr(ab[ii]);
        Form1.StringGrid3.Cells[2,ii+1] := FloatToStr(ct*ab[ii]/100);
      end;


    conduct := v1;

  end;



procedure TForm1.Exit1Click(Sender: TObject);
begin
  Halt;
end;

procedure TForm1.Open1Click(Sender: TObject);
var
  ii : integer;
begin
  if FileExists(dirinfo0+'\dirinf') then
    begin
      AssignFile(txt,dirinfo0+'\dirinf');
      Reset(txt);
      readln(txt, dirinfo);
      CloseFile(txt);
      SetCurrentDir(dirinfo);
    end;
  OpenDialog1.InitialDir := dirinfo;
  With OpenDialog1 do
  if Execute then
    begin
      FileDum := FileName;

      AssignFile(txt,dirinfo0+'\dirinf');
      Rewrite(txt);
      writeln(txt, dirinfo);
      CloseFile(txt);

      AssignFile(txt,FileDum);
      Reset(txt);
      ii := 0;
      while not eof(txt) do
       begin
        ii := ii + 1;
        readln(txt, x[ii],y[ii]);
       end;
      CloseFile(txt);
      ndata := ii;
      StringGrid1.RowCount := ndata+1;
      StringGrid1.Cells[0,0] := 'conc.(M)';
      StringGrid1.Cells[1,0] := 'cond_obsd(MC*M)';
      StringGrid1.Cells[2,0] := '[X-] (M)';
      StringGrid1.Cells[3,0] := 'cond_calcd (MC*M)';
      for ii := 1 to ndata do
        begin
          StringGrid1.Cells[0,ii] := Trim(FloatToStr(x[ii]));
          StringGrid1.Cells[1,ii] := Trim(FloatToStr(y[ii]));
        end;
    end;

  with Form1.Image1 do
    begin

      dxmin :=  100000000;
      dxmax := -100000000;
      dymin :=  100000000;
      dymax := -100000000;
      for ii := 1 to ndata do
        begin
          if x[ii] < dxmin then dxmin := x[ii];
          if x[ii] > dxmax then dxmax := x[ii];
          if y[ii] < dymin then dymin := y[ii];
          if y[ii] > dymax then dymax := y[ii];
        end;

        dxmin := 0;
        dymin := 0;
        dxmax := dxmax * 1.6;
        dymax := dymax * 1.2;
        Edit1.Text := FloatToStr(dxmin);
        Edit2.Text := FloatToStr(dxmax);
        Edit3.Text := FloatToStr(dymin);
        Edit4.Text := FloatToStr(dymax);


      gxmin := dxmin - (dxmax-dxmin)*0.05;
      gxmax := dxmax + (dxmax-dxmin)*0.05;
      gymin := dymin - (dymax-dymin)*0.05;
      gymax := dymax + (dymax-dymin)*0.05;

      gheight := Form1.Image1.Height;
      gwidth := Form1.Image1.Width;

      with Canvas do
        begin
          Pen.Width := 1;
          Brush.Color := clWhite;
          Rectangle(fx(dxmin),fy(dymin),fx(dxmax),fy(dymax));

          Pen.Color := clGreen;
          Rectangle(fx(dxmin), fy(dymin), fx(dxmax),fy(dymax));

        Pen.Width := 2;
        for ii := 1 to ndata do
          begin
        Pen.Color := clRed;
            Ellipse(fx(x[ii])-maru, fy(y[ii])-maru,
                    fx(x[ii])+maru, fy(y[ii])+maru);
        Pen.Color := clBlue;
            Ellipse(fx(x[ii])-maru, fy(Form1.SpinEdit4.value*y[ii]/x[ii]/1000000)-maru,
                    fx(x[ii])+maru, fy(Form1.SpinEdit4.value*y[ii]/x[ii]/1000000)+maru);
          end;

        end;


    end;


end;

procedure TForm1.InitializeClick(Sender: TObject);
var
  ii : integer;
begin
  Form1.StringGrid2.RowCount := Form1.SpinEdit1.value + 1;
  Form1.StringGrid2.Cells[0,0] := 'beta(n) (M)';
  Form1.StringGrid2.Cells[1,0] := 'K(n) (M)';

  b[1] := StrToFloat(Form1.beta1.text);
  k[1] := b[1];

  if Form1.CheckBox1.Checked then
    begin
      for ii := 2 to Form1.SpinEdit1.Value do
        begin
          k[ii] := k[ii-1]*Form1.SpinEdit2.value/100;
          b[ii] := b[ii-1]*k[ii];
        end;
    end;


   if (not Form1.CheckBox1.Checked)  then
     begin
       ShowMessage('Caution!! The current K2-Kn values (excluding K1) are used to set up all the beta(n) values.');
       for ii := 1 to Form1.StringGrid2.RowCount-1 do
         begin
           Form1.StringGrid2.Cells[0,ii] := FloatToStr(b[ii]);
           if ii=1 then
             begin
               k[1] := b[1];
             end
           else
             begin
               b[ii] := k[ii]*b[ii-1];
             end;
           Form1.StringGrid2.Cells[0,ii] := FloatToStr(b[ii]);
         end;


     end;


  for ii := 1 to Form1.SpinEdit1.value do
    begin
      Form1.StringGrid2.Cells[0,ii] := FloatToStr(b[ii]);
      Form1.StringGrid2.Cells[1,ii] := FloatToStr(k[ii]);
    end;

end;

procedure TForm1.SpinEdit1Change(Sender: TObject);
begin
  Form1.InitializeClick(Sender);
end;

procedure TForm1.SpinEdit2Change(Sender: TObject);
begin
  Form1.InitializeClick(Sender);
end;

procedure TForm1.Calc_LeftClick(Sender: TObject);
var
  value : extended;
begin
  value := sahen(StrToFloat(c0.text),StrToFloat(XConc.text));
  sahen_out.text := FloatToStr(value);
end;

procedure TForm1.CalcRightClick(Sender: TObject);
var
  value : extended;
begin
  value := uhen(StrToFloat(XConc.text));
  uhen_out.text := FloatToStr(value);
end;

procedure TForm1.RefineXClick(Sender: TObject);
var
  shift,fugo : extended;
  predev, dev : extended;

begin
if not FileExists('record.txt') then
begin
assignfile(txt,'record.txt');
rewrite(txt);
writeln(txt,'');
closefile(txt);
end;

 { InitializeClick(Sender);      }

  ct := StrToFloat(Form1.c0.text);
  cx := Form1.SpinEdit1.value*ct*0.999999999999999999;
  Form1.XConc.Text := FloatToStr(cx);

  dev := sahen(ct,cx)-uhen(cx);

  shift := 0.001*cx;
  fugo := -1;
  repeat
    predev := dev;
    cx := cx + shift*fugo;
    dev := sahen(ct,cx)-uhen(cx);
    if dev*predev < 0 then
      begin
        shift := shift*0.7;
        fugo := fugo*(-1);
      end
    else
      begin
        if abs(dev) > abs(predev) then
          begin
            shift := shift*0.7;
            fugo := fugo*(-1);
          end;
      end;

{

This is a route for checking the refinement procedures
by saving every values generated during the course of refinement

assignfile(txt,'record.txt');
append(txt);
writeln(txt,predev:25:22,' ',dev:25:22,' ',shift:25:22,' ',fugo:5:3);
closefile(txt);
}

  until abs(predev-dev) < 0.00000000000001;

  Form1.XConc.Text := FloatToStr(cx);
  Form1.Calc_LeftClick(Sender);
  Form1.CalcRightClick(Sender);

  conductivity.text := FloatToStr(conduct(cx));

  end;

procedure TForm1.Abundance1Click(Sender: TObject);
begin
  Form2.Visible := True;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  ii : integer;
begin
  for ii := 1 to Form1.StringGrid1.RowCount-1 do
    begin
      c0.text := Form1.StringGrid1.Cells[0,ii];
      ct := StrToFloat(Form1.StringGrid1.Cells[0,ii]);
      Form1.RefineXClick(Sender);
      Form1.StringGrid1.Cells[2,ii] := FloatToStr(cx);
      Form1.StringGrid1.Cells[3,ii] := conductivity.text;
    end;


  with Form1.Image1 do
    begin

      dxmin :=  100000000;
      dxmax := -100000000;
      dymin :=  100000000;
      dymax := -100000000;
      for ii := 1 to ndata do
        begin
          if x[ii] < dxmin then dxmin := x[ii];
          if x[ii] > dxmax then dxmax := x[ii];
          if y[ii] < dymin then dymin := y[ii];
          if y[ii] > dymax then dymax := y[ii];
        end;

        dxmin := 0;
        dymin := 0;
        dxmax := dxmax * 1.2;
        dymax := dymax * 1.2;
        Edit1.Text := FloatToStr(dxmin);
        Edit2.Text := FloatToStr(dxmax);
        Edit3.Text := FloatToStr(dymin);
        Edit4.Text := FloatToStr(dymax);


      gxmin := dxmin - (dxmax-dxmin)*0.05;
      gxmax := dxmax + (dxmax-dxmin)*0.05;
      gymin := dymin - (dymax-dymin)*0.05;
      gymax := dymax + (dymax-dymin)*0.05;

      gheight := Form1.Image1.Height;
      gwidth := Form1.Image1.Width;

      with Canvas do
        begin
          Brush.Color := clWhite;
          Rectangle(fx(gxmin),fy(gymin),fx(gxmax),fy(gymax));

          Pen.Width := 1;
          Pen.Color := clGreen;
          Rectangle(fx(dxmin), fy(dymin), fx(dxmax),fy(dymax));

        Pen.Width := 2;
        for ii := 1 to ndata do
          begin
        maru := 5;
        Pen.Color := clRed;
            Ellipse(fx(x[ii])-maru, fy(y[ii])-maru,
                    fx(x[ii])+maru, fy(y[ii])+maru);
        maru := 5;
        Pen.Color := clBlue;
            Ellipse(fx(x[ii])-maru, fy(Form1.SpinEdit4.value*y[ii]/x[ii]/1000000)-maru,
                    fx(x[ii])+maru, fy(Form1.SpinEdit4.value*y[ii]/x[ii]/1000000)+maru);
          end;

        Pen.Width := 1;
        Pen.Color := clGreen;
        maru := 3;

        MoveTo(fx(x[1]), fy(StrToFloat(Form1.StringGrid1.Cells[3,1])));
        Ellipse(fx(x[1])-maru, fy(StrToFloat(Form1.StringGrid1.Cells[3,1]))-maru,
                fx(x[1])+maru, fy(StrToFloat(Form1.StringGrid1.Cells[3,1]))+maru);

        for ii := 2 to Form1.StringGrid1.RowCount-1 do
          begin
            LineTo(fx(x[ii]), fy(StrToFloat(Form1.StringGrid1.Cells[3,ii])));
            Ellipse(fx(x[ii])-maru, fy(StrToFloat(Form1.StringGrid1.Cells[3,ii]))-maru,
                    fx(x[ii])+maru, fy(StrToFloat(Form1.StringGrid1.Cells[3,ii]))+maru);
          end;

        end;


    end;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  ii,jj : integer;
  xx,yy : extended;
begin
  Form2.StringGrid1.RowCount := SpinEdit3.value + 1;
  Form2.StringGrid1.ColCount := Form1.SpinEdit1.value + 3;
  Form2.StringGrid1.Cells[0,0] := 'conc.(M)';
  Form2.StringGrid1.Cells[1,0] := 'conduct.(MC*C)';

  for ii := 0 to SpinEdit1.value do
    begin
      Form2.StringGrid1.Cells[2+ii,0] := 'AX'+IntToStr(ii);
    end;

  for ii := 1 to SpinEdit3.value do
    begin
      ct := dxmin + ii*(dxmax-dxmin)/(SpinEdit3.value+1);
      c0.text := FloatToStr(ct);
      Form1.RefineXClick(Sender);
      Form1.StringGrid1.Cells[2,ii] := FloatToStr(cx);

      Form2.StringGrid1.Cells[0,ii] := FloatToStr(ct);
      Form2.StringGrid1.Cells[1,ii] := conductivity.text;
      for jj := 0 to Form1.SpinEdit1.value do
        begin
          Form2.StringGrid1.Cells[jj+2,ii] := FloatToStr(ab[jj]);
        end;
    end;



  with Form1.Image1 do
    begin

      dxmin :=  100000000;
      dxmax := -100000000;
      dymin :=  100000000;
      dymax := -100000000;
      for ii := 1 to ndata do
        begin
          if x[ii] < dxmin then dxmin := x[ii];
          if x[ii] > dxmax then dxmax := x[ii];
          if y[ii] < dymin then dymin := y[ii];
          if y[ii] > dymax then dymax := y[ii];
        end;

        dxmin := 0;
        dymin := 0;
        dxmax := dxmax * 1.6;
        dymax := dymax * 1.2;
        Edit1.Text := FloatToStr(dxmin);
        Edit2.Text := FloatToStr(dxmax);
        Edit3.Text := FloatToStr(dymin);
        Edit4.Text := FloatToStr(dymax);


      gxmin := dxmin - (dxmax-dxmin)*0.05;
      gxmax := dxmax + (dxmax-dxmin)*0.05;
      gymin := dymin - (dymax-dymin)*0.05;
      gymax := dymax + (dymax-dymin)*0.05;

      gheight := Form1.Image1.Height;
      gwidth := Form1.Image1.Width;

      with Canvas do
        begin
          Brush.Color := clWhite;
          Rectangle(fx(gxmin),fy(gymin),fx(gxmax),fy(gymax));

          Pen.Width := 1;
          Pen.Color := clGreen;
          Rectangle(fx(dxmin), fy(dymin), fx(dxmax),fy(dymax));

        Pen.Width := 2;
        for ii := 1 to ndata do
          begin
        maru := 5;
        Pen.Color := clRed;
            Ellipse(fx(x[ii])-maru, fy(y[ii])-maru,
                    fx(x[ii])+maru, fy(y[ii])+maru);
        maru := 5;
        Pen.Color := clBlue;
            Ellipse(fx(x[ii])-maru, fy(Form1.SpinEdit4.value*y[ii]/x[ii]/1000000)-maru,
                    fx(x[ii])+maru, fy(Form1.SpinEdit4.value*y[ii]/x[ii]/1000000)+maru);
          end;

        Pen.Width := 1;
        Pen.Color := clRed;
        maru := 3;

        xx := StrToFloat(Form2.StringGrid1.Cells[0,1]);
        yy := StrToFloat(Form2.StringGrid1.Cells[1,1]);
        MoveTo(fx(xx), fy(yy));
        Ellipse(fx(xx)-maru, fy(yy)-maru, fx(xx)+maru, fy(yy)+maru);

        for ii := 2 to Form2.StringGrid1.RowCount-1 do
          begin
            xx := StrToFloat(Form2.StringGrid1.Cells[0,ii]);
            yy := StrToFloat(Form2.StringGrid1.Cells[1,ii]);
            LineTo(fx(xx), fy(yy));
            Ellipse(fx(xx)-maru, fy(yy)-maru, fx(xx)+maru, fy(yy)+maru);
           end;

        Pen.Width := 1;
        Pen.Color := clBlue;
        maru := 3;

        xx := StrToFloat(Form2.StringGrid1.Cells[0,1]);
        yy := Form1.SpinEdit4.value*StrToFloat(Form2.StringGrid1.Cells[1,1])/1000000/xx;
        MoveTo(fx(xx), fy(yy));
        Ellipse(fx(xx)-maru, fy(yy)-maru, fx(xx)+maru, fy(yy)+maru);

        for ii := 2 to Form2.StringGrid1.RowCount-1 do
          begin
            xx := StrToFloat(Form2.StringGrid1.Cells[0,ii]);
            yy := Form1.SpinEdit4.value*StrToFloat(Form2.StringGrid1.Cells[1,ii])/1000000/xx;
            LineTo(fx(xx), fy(yy));
            Ellipse(fx(xx)-maru, fy(yy)-maru, fx(xx)+maru, fy(yy)+maru);

          end;

        end;


       Form2.Edit1.Text := Form1.Edit1.Text;
       Form2.Edit2.Text := Form1.Edit2.Text;
       Form2.Edit3.Text := '0';
       Form2.SpinEdit1.Value := 100;
       Form2.drawdistributionClick(Sender);

    end;


end;

procedure TForm1.Save1Click(Sender: TObject);
var
  ii,jj : integer;
  FileDum2 : string;
begin
  SaveDialog1.InitialDir := dirinfo;
  SaveDialog1.FileName := copy(FileDum,1,length(FileDum)-4)+'_results.txt';
  With OpenDialog1 do
  if Execute then
    begin
      FileDum2 := FileName;

      AssignFile(txt,dirinfo0+'\dirinf');
      Rewrite(txt);
      writeln(txt, dirinfo);
      CloseFile(txt);

      AssignFile(txt,FileDum2);
      Rewrite(txt);


      {raw data + anion concentration determined + others for plotting purposes}
      writeln(txt,'This file involves the data analaysis for '+FileDum);
      writeln(txt,'');
      writeln(txt,'Table 1. Row data + the X- concentrations determined + molar conductance vs. sqrt(conc)');
      writeln(txt,'');
      writeln(txt,'-------------------------------------------------------------');
      writeln(txt,'conc(M)','	','Conductivity()','	','[Anion X-] (M)','	','Sqrt(conc) (M^0.5)','	','MolarCond');
      writeln(txt,'-------------------------------------------------------------');
      for ii := 1 to Form1.StringGrid1.RowCount -1 do
        begin
           writeln(txt,Form1.StringGrid1.Cells[0,ii],'	',
                       Form1.StringGrid1.Cells[1,ii],'	',
                       Form1.StringGrid1.Cells[2,ii],'	',
                       FloatToStr(sqrt(StrToFloat(Form1.StringGrid1.Cells[0,ii])))  ,'	',
                       FloatToStr(StrToFloat(Form1.StringGrid1.Cells[1,ii])/StrToFloat(Form1.StringGrid1.Cells[0,ii]))  );

        end;
      writeln(txt,'');
      writeln(txt,'');
      writeln(txt,'Table 2. beta and setwise k valuse used in the calculations');
      writeln(txt,'-------------------------------------------------------------');
      writeln(txt,'beta1 = K1 = '+Form1.beta1.text);
      if Form1.CheckBox1.Checked then
        begin
          writeln(txt,'The model #1, Kn/Kn+1 = '+IntToStr(Form1.SpinEdit2.value)+'% (e.g., ca. 10-90 %) is used.');
        end;
      if not Form1.CheckBox1.Checked then
        begin
          writeln(txt,'The beta and Kn values are imported from a file or generated manually');
        end;
      writeln(txt,'');
      writeln(txt,'The common value for the molar conductances of RuMV over Z was supposed as: ' + Form1.MCA.text + ' [mScm2mol-1]');
      writeln(txt,'');
      writeln(txt,'The molar conductance for the PF6- anion was supposed as: '+Form1.MCX.text +' [mScm2mol-1]' );
      writeln(txt,'');
      writeln(txt,'The system used: AX'+IntToStr(Form1.SpinEdit1.value));
      writeln(txt,'---------------------------------------------------------------------');
      writeln(txt,'');
      writeln(txt,'');
      writeln(txt,'');
      writeln(txt,'Table 3. Beta(n) and Kn values used in the calculations');
      writeln(txt,'--------------------------------------------------------');
      writeln(txt,'Beta(n) values          Kn values');
      writeln(txt,'--------------------------------------------------------');
      for ii := 1 to Form1.StringGrid2.RowCount-1 do
        begin
          writeln(txt,'Beta('+IntToStr(ii)+') = ','	',Form1.StringGrid2.Cells[0,ii],'	',
                      'K'+IntToStr(ii)+' = ','	',Form1.StringGrid2.Cells[1,ii]);
        end;
      writeln(txt,'--------------------------------------------------------');
      writeln(txt,'');
      writeln(txt,'');
      writeln(txt,'');
      writeln(txt,'Table 4. Calculated Data');
      writeln(txt,'--------------------------------------------------------');
      write(txt,'conc(M)','	','conduct()','	','sqrt(conc)','	','MolarConduct.','	');
      for ii := 0 to Form1.SpinEdit1.value-1 do
        begin
          write(txt,'AX'+IntToStr(ii),'	');
        end;
      writeln(txt,'AX'+IntToStr(Form1.SpinEdit1.value));
      writeln(txt,'--------------------------------------------------------');
      for ii := 1 to Form2.StringGrid1.RowCount-1 do
        begin
          write(txt,Form2.StringGrid1.Cells[0,ii],'	');
          write(txt,Form2.StringGrid1.Cells[1,ii],'	');
          write(txt,FloatToStr(sqrt(StrToFloat(Form2.StringGrid1.Cells[0,ii]))),'	');
          write(txt,FloatToStr(StrToFloat(Form2.StringGrid1.Cells[1,ii])/StrToFloat(Form2.StringGrid1.Cells[0,ii])),'	');
          for jj := 2 to Form2.StringGrid1.ColCount-2 do
            begin
              write(txt,Form2.StringGrid1.Cells[jj,ii],'	');
            end;
          writeln(txt,Form2.StringGrid1.Cells[Form2.StringGrid1.ColCount-1,ii]);
        end;
      writeln(txt,'--------------------------------------------------------');
      writeln(txt,'');
      writeln(txt,'');
      writeln(txt,'');


      CloseFile(txt);



    end;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
  ii,jj : integer;
  value : extended;
begin
  ShowMessage('The file should consist of the stepwise formation constants only! OK??');

  OpenDialog1.InitialDir := dirinfo;
  With OpenDialog1 do
  if Execute then
    begin
      stepKFile := FileName;

      AssignFile(txt,dirinfo0+'\dirinf');
      Rewrite(txt);
      writeln(txt, dirinfo);
      CloseFile(txt);

      AssignFile(txt,stepKFile);
      Reset(txt);
      ii := 0;
      while not eof(txt) do
       begin
        ii := ii + 1;
        readln(txt, k[ii]);
       end;
      CloseFile(txt);
      nstepK := ii;

      Form1.SpinEdit1.value := nstepK;
      Form1.StringGrid2.RowCount := nstepK + 1;

      Form1.StringGrid2.Cells[0,0] := 'beta(n) (M)';
      Form1.StringGrid2.Cells[1,0] := 'K(n) (M)';

      for ii := 1 to nstepK do
        begin
          Form1.StringGrid2.Cells[1,ii] := FloatToStr(k[ii]);
          value := 1;
          for jj := 1 to ii do
            begin
              value := value*k[jj];
            end;
          b[ii] := value;
          Form1.StringGrid2.Cells[0,ii] := FloatToStr(value);
        end;

      Form1.CheckBox1.Checked := False;
    end;
end;

procedure TForm1.StringGrid2SelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
begin
  Form1.selectcol.value := ACol;
  Form1.selectrow.value := ARow;
  Form1.cellvalue.text := Form1.StringGrid2.Cells[Form1.selectcol.value,Form1.selectrow.value];
end;

procedure TForm1.AdoptClick(Sender: TObject);
var
  ii,jj : integer;
  value : extended;
begin
  Form1.StringGrid2.Cells[Form1.selectcol.value,Form1.selectrow.value] := Form1.cellvalue.text;
  if Form1.selectcol.value = 1 then
    begin
      k[Form1.selectrow.value] := StrToFloat(Form1.StringGrid2.Cells[Form1.selectcol.value,Form1.selectrow.value]);
      for ii := 1 to Form1.StringGrid2.RowCount-1 do
        begin
          Form1.StringGrid2.Cells[1,ii] := FloatToStr(k[ii]);
          value := 1;
          for jj := 1 to ii do
            begin
              value := value*k[jj];
            end;
          b[ii] := value;
          Form1.StringGrid2.Cells[0,ii] := FloatToStr(value);
        end;

      Form1.CheckBox1.Checked := False;

     end
  else
    begin
      b[Form1.selectrow.value] := StrToFloat(Form1.StringGrid2.Cells[Form1.selectcol.value,Form1.selectrow.value]);
      for ii := 1 to Form1.StringGrid2.RowCount-1 do
        begin
          Form1.StringGrid2.Cells[0,ii] := FloatToStr(b[ii]);
          if ii=1 then
            begin
              k[1] := b[1];
            end
          else
            begin
              k[ii] := b[ii]/b[ii-1];
            end;
          Form1.StringGrid2.Cells[1,ii] := FloatToStr(k[ii]);
        end;

      Form1.CheckBox1.Checked := False;
    end;
end;

procedure TForm1.Option1Click(Sender: TObject);
var
  ii : integer;
begin
  Form3.StringGrid2.RowCount := Form1.SpinEdit1.value+1;
  Form3.StringGrid2.Cells[0,0] := 'Species';
  Form3.StringGrid2.Cells[1,0] := 'Scaling Factor';
  for ii := 0 to Form1.SpinEdit1.value-1 do
    begin
      Form3.StringGrid2.Cells[0,ii+1] := 'AX'+IntToSTr(ii)+'^'+IntToStr(Form1.SpinEdit1.value-ii)+'+';
      Form3.StringGrid2.Cells[1,ii+1] := FloatToStr(scl[ii]);
    end;
  Form3.Visible := True;
  Form3.Show;
end;

initialization
  GetDir(0,dirinfo0);
  SetCurrentDir(dirinfo0);
  maru := 5;
  for i := 0 to 100 do
    begin
      scl[i] := 1;
    end;
end.
